<?php
/**
 * Created by PhpStorm.
 * User: arjanpronk
 * Date: 17/05/16
 * Time: 16:50
 */

define('PZZ_WIDGET_JSON_URL', 'http://zeef.io/images/custom/widgets/widgets.json');


class LinkPizza_Manager_Managed_Widget extends WP_Widget
{

    public function register_widget()
    {
        register_widget('LinkPizza_Manager_Managed_Widget');
    }

    /**
     * Sets up the widgets name
     *
     * @return LinkPizza_Manager_Managed_Widget
     * @since    1.0.0
     *
     */
    public function __construct()
    {
        $widget_ops = array(
            'classname' => 'LinkPizza_Manager_Managed_Widget',
            'description' => __('use a pre-selected list of links', 'linkpizza-manager'),
        );
        parent::__construct('LinkPizza_Manager_Managed_Widget', __('LinkPizza Automatic Ads', 'linkpizza-manager'), $widget_ops);

    }

    /**
     * Outputs the content of the widget
     *
     * @param array $args
     * @param array $instance
     */
    public function widget($args, $instance)
    {
        extract($args);
        if(!empty($instance['pzz_block_id']) && !empty($instance['pzz_block_height']) && !empty($instance['pzz_block_width'])){
            echo $before_widget;
            ?>
            <!-- ZEEF widget start --><iframe id="widget_pzz" src="//zeef.io/block/<?php echo $instance['pzz_block_id'];?>?lpuid=<?php $userid = get_option( 'pzz_id' );if ( $userid != false ) { echo $userid;} else{ echo 13003;} ?>&max_links=7&show_curator=0&show_logo=0" width="<?php echo $instance['pzz_block_width'];?>" height="<?php echo $instance['pzz_block_height'];?>" frameborder="0" scrolling="no"></iframe><!-- ZEEF widget end -->
            <?php
            echo $after_widget;
        }
    }

    /**
     * Outputs the options form on admin
     *
     * @param array $instance The widget options
     */
    public function form($instance)
    {
        if(!empty($instance['pzz_block_id'])){
            $pzz_block_id = $instance['pzz_block_id'];
        }else{
            $pzz_block_id = 0;
        }

        if(!empty($instance['pzz_block_height'])){
            $pzz_block_height = $instance['pzz_block_height'];
        }else{
            $pzz_block_height = 250;
        }

        if(!empty($instance['pzz_block_width'])){
            $pzz_block_width = $instance['pzz_block_width'];
        }else{
            $pzz_block_width = 300;
        }


        ?>

        <p>
            <label for="<?php echo $this->get_field_id('text'); ?>"><?php echo __('List','linkpizza-manager')?>
                <select class='widefat' id="<?php echo $this->get_field_id('pzz_block_id'); ?>"
                        name="<?php echo $this->get_field_name('pzz_block_id'); ?>" type="text">
                        <?php
                            $response = wp_remote_get(PZZ_WIDGET_JSON_URL);
                            if( is_wp_error( $response ) ) {
                                ?>  Widgets could not be loaded <?php
                            }
                            else{
                                try {
                                $json = json_decode( $response['body'] );
                                    if(!empty($json)){
                                        foreach ($json as $widget){
                                            ?>
                                            <option value='<?php echo $widget->id ?>'<?php echo ($pzz_block_id==$widget->id)?'selected':''; ?>>
                                                <?php echo $widget->title ?>
                                            </option>
                                            <?php
                                        }
                                        ?> </select> </label><?php
                                    }
                                    else{

                                        ?> </select> </label>  <?php echo __('Widgets could not be loaded, please try again later','linkpizza-manager');
                                    }
                                } catch ( Exception $ex ) {
                                    echo __('Widgets could not be loaded, please try again later','linkpizza-manager');
                                }
                            }
                        ?>
        </p>
        <p>
            <label for="<?php echo $this->get_field_id('label'); ?>"><?php echo __('Height (absolute or in %)','linkpizza-manager')?>
                <input class="widefat" id="<?php echo $this->get_field_id('pzz_block_height');?>" name="<?php echo $this->get_field_name('pzz_block_height'); ?>"  type="text" value="<?php echo $pzz_block_height?>">
            </label>
        </p>
        <p>
            <label for="<?php echo $this->get_field_id('label'); ?>"><?php echo __('Width (absolute or in %)','linkpizza-manager')?>
                <input class="widefat" id="<?php echo $this->get_field_id('pzz_block_width');?>" name="<?php echo $this->get_field_name('pzz_block_width'); ?>"  type="text" value="<?php echo $pzz_block_width?>">
            </label>
        </p>

        <?php
    }

    /**
     * Processing widget options on save
     *
     * @param array $new_instance The new options
     * @param array $old_instance The previous options
     */
    public function update($new_instance, $old_instance)
    {
        $instance = $old_instance;
        if(!empty($new_instance['pzz_block_id'])){
            $instance['pzz_block_id'] = $new_instance['pzz_block_id'];
        }
        if(!empty($new_instance['pzz_block_width']) && preg_match('/^[1-9]+\d*%?$/', $new_instance['pzz_block_width'])) {
            $instance['pzz_block_width'] = $new_instance['pzz_block_width'];
        }
        if(!empty($new_instance['pzz_block_height']) && preg_match('/^[1-9]+\d*%?$/', $new_instance['pzz_block_height'])) {
            $instance['pzz_block_height'] = $new_instance['pzz_block_height'];
        }
        return $instance;
    }

}
