<?php
/**
 * Created by PhpStorm.
 * User: arjanpronk
 * Date: 10/05/16
 * Time: 14:49
 */

class LinkPizza_Manager_Widget extends WP_Widget
{

    public function register_widget()
    {
        register_widget('LinkPizza_Manager_Widget');
    }

    /**
     * Sets up the widgets name
     *
     * @return LinkPizza_Manager_Widget
     * @since    1.0.0
     *
     */
    public function __construct()
    {
        $widget_ops = array(
            'classname' => 'LinkPizza_Manager_Widget',
            'description' => __('Allows you to create a list of links', 'linkpizza-manager'),
        );
        parent::__construct('LinkPizza_Manager_Widget', __('LinkPizza Links', 'linkpizza-manager'), $widget_ops);

        add_action('admin_enqueue_scripts', array($this,'pzz_load_scripts'));

    }

    /**
     * Outputs the content of the widget
     *
     * @param array $args
     * @param array $instance
     */
    public function widget($args, $instance)
    {
        extract($args);
        $title = apply_filters('widget_title', empty($instance['title']) ? __('List') : $instance['title']);
        $amount = empty($instance['amount']) ? 0 : $instance['amount'];

        for ($i = 1; $i <= $amount; $i++) {
            if(!empty($instance['item'.$i])) :
                $items[$i-1] = $instance['item'.$i];
                $item_links[$i-1] = $instance['item_link'.$i];
                $item_targets[$i-1] = isset($instance['item_target'.$i]) ? $instance['item_target'.$i] : false;
            endif;
        }

        echo $before_widget .  $before_title . $title . $after_title;
        echo("<ul "); ?> class="list">

        <?php
        if(!empty($items)) :
            foreach ($items as $num => $item) :
                if (!empty($item)) :
                    if (empty($item_links[$num])) :
                        echo("<li>" . $item . "</li>");
                    else :
                        if($item_targets[$num]) :
                            echo("<li><a href='" . $item_links[$num] . "' target='_blank'>" . $item . "</a></li>");
                        else :
                            echo("<li><a href='" . $item_links[$num] . "'>" . $item . "</a></li>");
                        endif;
                    endif;
                endif;
            endforeach;
        endif;

        echo("</ul>");
        echo $after_widget;
    }

    /**
     * Outputs the options form on admin
     *
     * @param array $instance The widget options
     */
    public function form($instance)
    {
        $instance = wp_parse_args((array)$instance, array('title' => '', 'text' => '', 'title_link' => ''));
        $title = strip_tags($instance['title']);
        $amount = empty($instance['amount']) ? 3 : $instance['amount'];

        for ($i = 1; $i <= $amount; $i++) {
            $items[$i] = empty($instance['item' . $i]) ? '' : $instance['item' . $i];
            $item_links[$i] = empty($instance['item_link' . $i]) ? '' : $instance['item_link' . $i];
            $item_targets[$i] = empty($instance['item_target' . $i]) ? 'on' : $instance['item_target' . $i];
        }
        ?>
        <p><label for="<?php echo $this->get_field_id('title'); ?>"><?php _e('Title:'); ?></label>
            <input class="widefat" id="<?php echo $this->get_field_id('title'); ?>"
                   name="<?php echo $this->get_field_name('title'); ?>" type="text"
                   value="<?php echo esc_attr($title); ?>" placeholder="<?php echo _e( "Enter the title of the block here", 'linkpizza-manager' ); ?>"/></p>
        <div class="pzz-list">
            <?php foreach ($items as $num => $item) :
                $item = esc_attr($item);
                $item_link = esc_attr($item_links[$num]);
                $checked = checked($item_targets[$num], 'on', false);
                ?>

                <div id="<?php echo $this->get_field_id($num); ?>" class="list-item">
                    <h5 class="moving-handle"><span class="number"><?php echo $num; ?></span>. <span
                            class="item-title"><?php echo $item; $response = pzz_do_oauth_call_with_refresh_check(PZZ_OIDC_API_BASE_PATH.'/url/isMonetizable?url='.$item_link.'',array(),false);
                            if($response == 'true'){
                                ?> <img src="<?php echo plugins_url('../admin/assets/dolar-sign-small-orange.png', __FILE__ ); ?>" alt="<?php _e( "Monetized", 'linkpizza-manager' ); ?>" title="<?php _e( "Monetized", 'linkpizza-manager' ); ?>" style="margin: -4px;padding-left: 25px;"/> <?php
                            }else{
                                ?> <img src="<?php echo plugins_url('../admin/assets/dolar-sign-small.png', __FILE__ ); ?>" alt="<?php _e( "Not Monetized", 'linkpizza-manager' ); ?>" title="<?php _e( "Not Monetized", 'linkpizza-manager' ); ?>" style="margin: -4px;padding-left: 25px;"/> <?php
                            }?></span><a class="pzz-action hide-if-no-js"></a></h5>
                    <div class="pzz-edit-item">
                        <label
                            for="<?php echo $this->get_field_id('item' . $num); ?>"><?php echo __("Text"); ?> <?php echo __("(required)",'linkpizza-manager')?></label>
                        <input class="widefat" id="<?php echo $this->get_field_id('item' . $num); ?>"
                               name="<?php echo $this->get_field_name('item' . $num); ?>" type="text"
                               value="<?php echo $item; ?>"/>
                        <label
                            for="<?php echo $this->get_field_id('item_link' . $num); ?>"><?php echo __("Link"); ?></label>
                        <input class="widefat" id="<?php echo $this->get_field_id('item_link' . $num); ?>"
                               name="<?php echo $this->get_field_name('item_link' . $num); ?>" type="text"
                               value="<?php echo $item_link; ?>" placeholder="http://"/>
                        <input type="checkbox" name="<?php echo $this->get_field_name('item_target' . $num); ?>"
                               id="<?php echo $this->get_field_id('item_target' . $num); ?>" <?php echo $checked; ?> />
                        <label
                            for="<?php echo $this->get_field_id('item_target' . $num); ?>"><?php echo __("Open in new window",'linkpizza-manager'); ?></label>
                        <a class="pzz-delete hide-if-no-js"><?php echo __("Remove"); ?>
                        </a>
                    </div>
                </div>

            <?php endforeach;

            if (isset($_GET['editwidget']) && $_GET['editwidget']) : ?>
                <table class='widefat'>
                    <thead>
                    <tr>
                        <th><?php echo __("Item"); ?></th>
                        <th><?php echo __("Position/Action"); ?></th>
                    </tr>
                    </thead>
                    <tbody>
                    <?php foreach ($items as $num => $item) : ?>
                        <tr>
                            <td><?php echo esc_attr($item); ?></td>
                            <td>
                                <select id="<?php echo $this->get_field_id('position' . $num); ?>"
                                        name="<?php echo $this->get_field_name('position' . $num); ?>">
                                    <option><?php echo __('&mdash; Select &mdash;'); ?></option>
                                    <?php for ($i = 1; $i <= count($items); $i++) {
                                        if ($i == $num) {
                                            echo "<option value='$i' selected>$i</option>";
                                        } else {
                                            echo "<option value='$i'>$i</option>";
                                        }
                                    } ?>
                                    <option value="-1"><?php echo __("Delete"); ?></option>
                                </select>
                            </td>
                        </tr>
                    <?php endforeach; ?>
                    </tbody>
                </table>

                <div class="pzz-row">
                    <input type="checkbox" name="<?php echo $this->get_field_name('new_item'); ?>"
                           id="<?php echo $this->get_field_id('new_item'); ?>"/> <label
                        for="<?php echo $this->get_field_id('new_item'); ?>"><?php echo __("Add Extra Link"); ?></label>
                </div>
            <?php endif; ?>

        </div>
        <div class="pzz-row hide-if-no-js">
            <a class="pzz-add button-secondary"><?php echo __("Add Item"); ?></a>
        </div>

        <input type="hidden" id="<?php echo $this->get_field_id('amount'); ?>" class="amount"
               name="<?php echo $this->get_field_name('amount'); ?>" value="<?php echo $amount ?>"/>
        <input type="hidden" id="<?php echo $this->get_field_id('order'); ?>" class="order"
               name="<?php echo $this->get_field_name('order'); ?>"
               value="<?php echo implode(',', range(1, $amount)); ?>"/>
        <?php

    }

    /**
     * Processing widget options on save
     *
     * @param array $new_instance The new options
     * @param array $old_instance The previous options
     */
    public function update($new_instance, $old_instance)
    {
        //$instance = $old_instance;
        $instance['title'] = strip_tags($new_instance['title']);
        $amount = $new_instance['amount'];

        if ( isset($new_instance['position1'])) {
            for($i=1; $i<= $new_instance['amount']; $i++){
                if($new_instance['position'.$i] != -1){
                    $position[$i] = $new_instance['position'.$i];
                }else{
                    $amount--;
                }
            }
            if($position){
                asort($position);
                $order = array_keys($position);
                if(strip_tags($new_instance['new_item'])){
                    $amount++;
                    array_push($order, $amount);
                }
            }

        }else{
            $order = explode(',',$new_instance['order']);
            foreach($order as $key => $order_str){
                $num = strrpos($order_str,'-');
                if($num !== false){
                    $order[$key] = substr($order_str,$num+1);
                }
            }
        }

        if($order){
            foreach ($order as $i => $item_num) {
                $instance['item'.($i+1)] = empty($new_instance['item'.$item_num]) ? '' : strip_tags($new_instance['item'.$item_num]);
                $instance['item_link'.($i+1)] = empty($new_instance['item_link'.$item_num]) ? '' : $this->normalize_url(strip_tags($new_instance['item_link'.$item_num]));
                $instance['item_target'.($i+1)] = empty($new_instance['item_target'.$item_num]) ? '' : strip_tags($new_instance['item_target'.$item_num]);
            }
        }

        $instance['amount'] = $amount;
        return $instance;
    }


    public function pzz_load_scripts($hook)
    {
        if ($hook != 'widgets.php')
            return;
        if (!isset($_GET['editwidget'])) {
            wp_enqueue_script('pzz-link-sort-js', plugin_dir_url(__FILE__) . 'js/pzz-link-sort.js');
        }
        wp_enqueue_style('pzz-link-css', plugin_dir_url(__FILE__) . 'css/pzz-link-css.css');
    }

    public function normalize_url($url){
        if(!$this->startsWith($url, '/') && !filter_var($url, FILTER_VALIDATE_URL)){
            if(filter_var('http://'.$url, FILTER_VALIDATE_URL)){
                return 'http://'.$url;
            }
            return $url;
        }
        return $url;
    }


    public function startsWith($string, $tofind) {
        return $tofind === "" || strrpos($string, $tofind, -strlen($string)) !== false;
    }
}
